PF-build.sh 38 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_29
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Audrino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multilanguage vairants it makes it easier to find missing or unused transltions.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to scrpit commits
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. #### Start check if OSTYPE is supported
  133. OS_FOUND=$( command -v uname)
  134. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  135. linux*)
  136. TARGET_OS="linux"
  137. ;;
  138. msys*|cygwin*|mingw*)
  139. # or possible 'bash on windows'
  140. TARGET_OS='windows'
  141. ;;
  142. nt|win*)
  143. TARGET_OS='windows'
  144. ;;
  145. *)
  146. TARGET_OS='unknown'
  147. ;;
  148. esac
  149. # Windows
  150. if [ $TARGET_OS == "windows" ]; then
  151. if [ $(uname -m) == "x86_64" ]; then
  152. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  153. Processor="64"
  154. elif [ $(uname -m) == "i386" ]; then
  155. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  156. Processor="32"
  157. else
  158. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  159. echo "Please refer to the notes of build.sh$(tput sgr0)"
  160. exit 1
  161. fi
  162. # Linux
  163. elif [ $TARGET_OS == "linux" ]; then
  164. if [ $(uname -m) == "x86_64" ]; then
  165. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  166. Processor="64"
  167. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  168. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  169. Processor="32"
  170. else
  171. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  172. echo "Please refer to the notes of build.sh$(tput sgr0)"
  173. exit 1
  174. fi
  175. else
  176. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  177. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  178. echo "Read the notes of build.sh$(tput sgr0)"
  179. exit 1
  180. fi
  181. sleep 2
  182. #### End check if OSTYPE is supported
  183. #### Prepare bash environment and check if wget, zip and other needed things are available
  184. # Check wget
  185. if ! type wget > /dev/null; then
  186. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  187. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  188. exit 2
  189. fi
  190. # Check for zip
  191. if ! type zip > /dev/null; then
  192. if [ $TARGET_OS == "windows" ]; then
  193. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  194. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  195. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  196. echo "Run git Bash under Administrator privilege and"
  197. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  198. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  199. exit 3
  200. elif [ $TARGET_OS == "linux" ]; then
  201. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  202. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  203. sudo apt-get update && apt-get install zip
  204. exit 3
  205. fi
  206. fi
  207. # Check python ... needed during language build
  208. if ! type python > /dev/null; then
  209. if [ $TARGET_OS == "windows" ]; then
  210. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  211. exit 4
  212. elif [ $TARGET_OS == "linux" ]; then
  213. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  214. echo "As Python 2.x will not be maintained from 2020 please,"
  215. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  216. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  217. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  218. sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  219. exit 4
  220. fi
  221. fi
  222. #### End prepare bash / Linux environment
  223. #### Set build environment
  224. ARDUINO_ENV="1.8.5"
  225. BUILD_ENV="1.0.6"
  226. BOARD="prusa_einsy_rambo"
  227. BOARD_PACKAGE_NAME="PrusaResearch"
  228. BOARD_VERSION="1.0.3"
  229. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  230. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  231. BOARD_FILENAME="prusa3dboards"
  232. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  233. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  234. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  235. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  236. LIB="PrusaLibrary"
  237. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  238. # List few useful data
  239. echo
  240. echo "Script path :" $SCRIPT_PATH
  241. echo "OS :" $OS
  242. echo "OS type :" $TARGET_OS
  243. echo ""
  244. echo "Ardunio IDE :" $ARDUINO_ENV
  245. echo "Build env :" $BUILD_ENV
  246. echo "Board :" $BOARD
  247. echo "Package name:" $BOARD_PACKAGE_NAME
  248. echo "Board v. :" $BOARD_VERSION
  249. echo "Specific Lib:" $LIB
  250. echo ""
  251. #### Start prepare building environment
  252. #Check if build exists and creates it if not
  253. if [ ! -d "../PF-build-dl" ]; then
  254. mkdir ../PF-build-dl || exit 5
  255. fi
  256. cd ../PF-build-dl || exit 6
  257. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  258. # Check if PF-build-env-<version> exists and downloads + creates it if not
  259. # The build environment is based on the supported Arduino IDE portable version with some changes
  260. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  261. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  262. mkdir ../PF-build-env-$BUILD_ENV
  263. sleep 5
  264. fi
  265. # Download and extract supported Arduino IDE depending on OS
  266. # Windows
  267. if [ $TARGET_OS == "windows" ]; then
  268. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  269. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  270. sleep 2
  271. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  272. echo "$(tput sgr 0)"
  273. fi
  274. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  275. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  276. sleep 2
  277. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  278. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  279. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  280. echo "$(tput sgr0)"
  281. fi
  282. fi
  283. # Linux
  284. if [ $TARGET_OS == "linux" ]; then
  285. # 32 or 64 bit version
  286. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  287. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  288. sleep 2
  289. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  290. echo "$(tput sgr 0)"
  291. fi
  292. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  293. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  294. sleep 2
  295. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  296. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  297. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  298. echo "$(tput sgr0)"
  299. fi
  300. fi
  301. # Make Arduino IDE portable
  302. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  303. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  304. fi
  305. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  306. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  307. fi
  308. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  309. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  310. fi
  311. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  312. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  313. fi
  314. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  315. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  316. fi
  317. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  318. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  319. fi
  320. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  321. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  322. fi
  323. # Change Arduino IDE preferences
  324. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  325. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  326. sleep 2
  327. echo "update.check"
  328. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  329. echo "board"
  330. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  331. echo "editor.linenumbers"
  332. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  333. echo "boardsmanager.additional.urls"
  334. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  335. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  336. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  337. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  338. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  339. echo "$(tput sgr0)"
  340. fi
  341. # Download and extract Prusa Firmware related parts
  342. # Download and extract PrusaResearchRambo board
  343. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  344. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  345. sleep 2
  346. wget $BOARD_FILE_URL || exit 9
  347. fi
  348. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  349. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  350. sleep 2
  351. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  352. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  353. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  354. fi
  355. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  356. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  357. fi
  358. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  359. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  360. fi
  361. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  362. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  363. fi
  364. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  365. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  366. echo "$(tput sgr 0)"
  367. fi
  368. # Download and extract Prusa Firmware specific library files
  369. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  370. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  371. sleep 2
  372. wget $PF_BUILD_FILE_URL || exit 11
  373. echo "$(tput sgr 0)"
  374. fi
  375. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  376. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  377. sleep 2
  378. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  379. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  380. echo "$(tput sgr0)"
  381. fi
  382. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  383. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  384. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  385. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  386. sleep 2
  387. fi
  388. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  389. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  390. sleep 2
  391. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  392. sleep 2
  393. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  394. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  395. echo "$(tput sgr0)"
  396. fi
  397. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  398. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  399. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  400. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  401. sleep 2
  402. echo "$(tput sgr0)"
  403. exit 13
  404. fi
  405. #### End prepare building
  406. #### Start
  407. cd $SCRIPT_PATH
  408. # First argument defines which variant of the Prusa Firmware will be compiled
  409. if [ -z "$1" ] ; then
  410. # Select which variant of the Prusa Firmware will be compiled, like
  411. PS3="Select a variant: "
  412. while IFS= read -r -d $'\0' f; do
  413. options[i++]="$f"
  414. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  415. select opt in "${options[@]}" "All" "Quit"; do
  416. case $opt in
  417. *.h)
  418. VARIANT=$(basename "$opt" ".h")
  419. VARIANTS[i++]="$opt"
  420. break
  421. ;;
  422. "All")
  423. VARIANT="All"
  424. VARIANTS=${options[*]}
  425. break
  426. ;;
  427. "Quit")
  428. echo "You chose to stop"
  429. exit
  430. ;;
  431. *)
  432. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  433. ;;
  434. esac
  435. done
  436. else
  437. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  438. VARIANTS=$1
  439. else
  440. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  441. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  442. echo "$(tput sgr0)"
  443. exit 21
  444. fi
  445. fi
  446. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  447. #Check default language mode
  448. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  449. if [ -z "$2" ] ; then
  450. PS3="Select a language: "
  451. echo
  452. echo "Which lang-build do you want?"
  453. select yn in "Multi languages" "English only"; do
  454. case $yn in
  455. "Multi languages")
  456. LANGUAGES="ALL"
  457. break
  458. ;;
  459. "English only")
  460. LANGUAGES="EN_ONLY"
  461. break
  462. ;;
  463. *)
  464. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  465. ;;
  466. esac
  467. done
  468. else
  469. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  470. LANGUAGES=$2
  471. else
  472. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  473. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  474. exit 22
  475. fi
  476. fi
  477. #Check if DEV_STATUS is selected via argument 3
  478. if [ ! -z "$3" ] ; then
  479. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" || "$3" == "UNKNOWN" ]] ; then
  480. DEV_STATUS_SELECTED=$3
  481. else
  482. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  483. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  484. exit 23
  485. fi
  486. fi
  487. # check if script has been started with arguments
  488. if [ "$#" -eq "0" ] ; then
  489. OUTPUT=1
  490. else
  491. OUTPUT=0
  492. fi
  493. #echo "Output is:" $OUTPUT
  494. #Set BUILD_ENV_PATH
  495. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 24
  496. BUILD_ENV_PATH="$( pwd -P )"
  497. cd ../..
  498. #Checkif BUILD_PATH exists and if not creates it
  499. if [ ! -d "Prusa-Firmware-build" ]; then
  500. mkdir Prusa-Firmware-build || exit 25
  501. fi
  502. #Set the BUILD_PATH for Arduino IDE
  503. cd Prusa-Firmware-build || exit 26
  504. BUILD_PATH="$( pwd -P )"
  505. for v in ${VARIANTS[*]}
  506. do
  507. VARIANT=$(basename "$v" ".h")
  508. # Find firmware version in Configuration.h file and use it to generate the hex filename
  509. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  510. # Find build version in Configuration.h file and use it to generate the hex filename
  511. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  512. # Check if the motherboard is an EINSY and if so only one hex file will generated
  513. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  514. # Check development status
  515. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  516. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  517. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  518. DEV_STATUS="RC"
  519. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  520. DEV_STATUS="ALPHA"
  521. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  522. DEV_STATUS="BETA"
  523. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  524. DEV_STATUS="DEVEL"
  525. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  526. DEV_STATUS="DEBUG"
  527. else
  528. DEV_STATUS="UNKNOWN"
  529. echo
  530. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  531. PS3="Select YES only if source code is tested and trusted: "
  532. select yn in "Yes" "No"; do
  533. case $yn in
  534. Yes)
  535. DEV_STATUS="GOLD"
  536. DEV_STATUS_SELECTED="GOLD"
  537. break
  538. ;;
  539. No)
  540. DEV_STATUS="UNKNOWN"
  541. DEV_STATUS_SELECTED="UNKNOWN"
  542. break
  543. ;;
  544. *)
  545. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  546. ;;
  547. esac
  548. done
  549. fi
  550. else
  551. DEV_STATUS=$DEV_STATUS_SELECTED
  552. fi
  553. #Prepare hex files folders
  554. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  555. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  556. fi
  557. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  558. #Check if exactly the same hexfile already exists
  559. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  560. echo ""
  561. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  562. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  563. if [ $OUTPUT == "1" ] ; then
  564. read -t 10 -p "Press Enter to continue..."
  565. fi
  566. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  567. echo ""
  568. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  569. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  570. if [ $OUTPUT == "1" ] ; then
  571. read -t 10 -p "Press Enter to continue..."
  572. fi
  573. fi
  574. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  575. echo ""
  576. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  577. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  578. if [ $OUTPUT == "1" ] ; then
  579. read -t 10 -p "Press Enter to continue..."
  580. fi
  581. fi
  582. #List some useful data
  583. echo "$(tput setaf 2)$(tput setab 7) "
  584. echo "Variant :" $VARIANT
  585. echo "Firmware :" $FW
  586. echo "Build # :" $BUILD
  587. echo "Dev Check :" $DEV_CHECK
  588. echo "DEV Status :" $DEV_STATUS
  589. echo "Motherboard:" $MOTHERBOARD
  590. echo "Languages :" $LANGUAGES
  591. echo "Hex-file Folder:" $OUTPUT_FOLDER
  592. echo "$(tput sgr0)"
  593. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  594. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  595. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  596. else
  597. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  598. read -t 10 -p "Press Enter to continue..."
  599. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  600. fi
  601. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  602. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  603. # set FW_REPOSITORY
  604. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  605. #Prepare english only or multilanguage version to be build
  606. if [ $LANGUAGES == "EN_ONLY" ]; then
  607. echo " "
  608. echo "English only language firmware will be built"
  609. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  610. echo " "
  611. else
  612. echo " "
  613. echo "Multi-language firmware will be built"
  614. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  615. echo " "
  616. fi
  617. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  618. # if [ $TARGET_OS == "windows" ]; then
  619. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  620. # fi
  621. #### End of Prepare building
  622. #### Start building
  623. export ARDUINO=$BUILD_ENV_PATH
  624. #echo $BUILD_ENV_PATH
  625. #export BUILDER=$ARDUINO/arduino-builder
  626. echo
  627. #read -t 5 -p "Press Enter..."
  628. echo
  629. echo "Start to build Prusa Firmware ..."
  630. echo "Using variant $VARIANT$(tput setaf 3)"
  631. if [ $OUTPUT == "1" ] ; then
  632. sleep 2
  633. fi
  634. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  635. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  636. echo "$(tput sgr 0)"
  637. if [ $LANGUAGES == "ALL" ]; then
  638. echo "$(tput setaf 2)"
  639. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  640. echo "$(tput sgr 0)"
  641. if [ $OUTPUT == "1" ] ; then
  642. sleep 2
  643. fi
  644. cd $SCRIPT_PATH/lang
  645. echo "$(tput setaf 3)"
  646. ./config.sh || exit 31
  647. echo "$(tput sgr 0)"
  648. # Check if previous languages and firmware build exist and if so clean them up
  649. if [ -f "lang_en.tmp" ]; then
  650. echo ""
  651. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  652. if [ $OUTPUT == "1" ] ; then
  653. read -t 10 -p "Press Enter to continue..."
  654. fi
  655. echo "$(tput setaf 3)"
  656. ./lang-clean.sh
  657. echo "$(tput sgr 0)"
  658. fi
  659. if [ -f "progmem.out" ]; then
  660. echo ""
  661. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  662. if [ $OUTPUT == "1" ] ; then
  663. read -t 10 -p "Press Enter to continue..."
  664. fi
  665. echo "$(tput setaf 3)"
  666. ./fw-clean.sh
  667. echo "$(tput sgr 0)"
  668. fi
  669. # build languages
  670. echo "$(tput setaf 3)"
  671. ./lang-build.sh || exit 32
  672. # Combine compiled firmware with languages
  673. ./fw-build.sh || exit 33
  674. cp not_tran.txt not_tran_$VARIANT.txt
  675. cp not_used.txt not_used_$VARIANT.txt
  676. echo "$(tput sgr 0)"
  677. # Check if the motherboard is an EINSY and if so only one hex file will generated
  678. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  679. # If the motherboard is an EINSY just copy one hexfile
  680. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  681. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  682. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  683. else
  684. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  685. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  686. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  687. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  688. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  689. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  690. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  691. if [ $TARGET_OS == "windows" ]; then
  692. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  693. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  694. elif [ $TARGET_OS == "linux" ]; then
  695. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  696. fi
  697. fi
  698. # Cleanup after build
  699. echo "$(tput setaf 3)"
  700. ./fw-clean.sh || exit 34
  701. ./lang-clean.sh || exit 35
  702. echo "$(tput sgr 0)"
  703. else
  704. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  705. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  706. fi
  707. # Cleanup Firmware
  708. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  709. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  710. then
  711. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  712. fi
  713. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  714. then
  715. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  716. fi
  717. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  718. then
  719. rm $SCRIPT_PATH/lang/not_tran.txt
  720. fi
  721. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  722. then
  723. rm $SCRIPT_PATH/lang/not_used.txt
  724. fi
  725. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  726. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  727. echo $MULTI_LANGUAGE_CHECK
  728. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  729. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  730. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  731. if [ $OUTPUT == "1" ] ; then
  732. sleep 5
  733. fi
  734. done
  735. # Switch to hex path and list build files
  736. cd $SCRIPT_PATH
  737. cd ..
  738. echo "$(tput setaf 2) "
  739. echo " "
  740. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  741. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  742. #### End building